<?php
/**
 * @package		Joomla Bamboo Zen Grid Framework
 * @Type        Core Framework Files
 * @version		v1.0
 * @author		Joomal Bamboo http://www.joomlabamboo.com
 * @copyright 	Copyright (C) 2007 - 2010 Joomla Bamboo
 * @license		http://www.gnu.org/licenses/gpl-2.0.html GNU/GPLv2 only
 */

// no direct access
defined( '_JEXEC' ) or die( 'Restricted index access' );
jimport('joomla.html.html');
jimport('joomla.form.formfield');

/**
 * Renders a editors element
 *
 * @package 	Joomla.Framework
 * @subpackage		Form
 * @since		1.6
 */

class JFormFieldCompile extends JFormField
{
	/**
	* Element name
	*
	* @access	protected
	* @var		string
	*/
	
	protected $type = 'compile';

	protected function getInput()
	{
	}
	
	public function getLabel() {
		$label     = (string) $this->element['label'];
		$desc     = (string) $this->element['desc'];
		
		// Get module id
		$id =  $_SERVER['REQUEST_URI'];
		
		// Split all up until the id fragment
		$id = explode('id=', $id);
		
		// Make sure nothing comes after that
		if(isset($id[1])) {
			// Make sure nothing comes after that
			$id = explode('&', $id[1]);
			
			// This is the id
			$id = $id[0];
		} else {
			$id = 0;
		}
		
		
		ob_start(); ?>
			
			<a href="#" class="uk-button uk-button-primary zt-compile master" data-action="compile" data-file="master">Create master css</a>
			<a href="#" class="uk-button uk-button-primary zt-compile custom" data-action="compile" data-file="custom">Create custom css</a>
			
			<script>
			(function ($) {
				// Load Layout Function
				$(document).on('click', '.zt-compile:not(.disabled)', function() {
					
					$(this).addClass('active');
					$('.zt-compile:not(.active)').addClass('disabled');
					
					var action = $(this).attr('data-action');
					var file_type = $(this).attr('data-file');
					var variables = 'moduleid:<?php echo $id;?>|';
					
					$('.compile').each(function() {
						var id = $(this).attr('id');
							
						var value = $(this).val();
						
						if(typeof id !=="undefined" && typeof value !=="undefined") {
							id = id.replace('jform_params_','');
							variables += id + ':' +value + '|';
						}
					});
				
					var url = '<?php echo JURI::base();?>?option=com_ajax&plugin=zentools2&format=raw';
					var value   = variables,
						action  = action,
						request = {
								'option' : 'com_ajax',
								'plugin' : 'zentools2',
								'cmd'    : action,
								'data'   : variables,
								'id'	 : <?php echo $id;?>,
								'type'	 : file_type
									
							};
					$.ajax({
					 	url: url,
					 	method: 'get',
					 	context: document.body,
					 	type: 'POST',
					 	data   : request,
					 	
					 	beforeSend: function () {
					 			
					 		$('.zt-compile.active').text('Compiling less to css');
					 	},
					 		
					 	success: function (data) {
					 		
					 		$('.zt-compile.active').text('Less has been compiled to css');
					 		
					 		if($('.zt-compile.active').hasClass('master')) {
					 				var text = 'Create master css';
					 			} else {
					 				var text = 'Create custom css';
					 				$('#checkfile').html('Custom file created for this module.');
					 			}
					 			
					 		setTimeout(function() {
					 			
					 			$('.zt-compile.active').text(text).removeClass('active');
					 			$('.zt-compile').removeClass('disabled');	
					 		}, 3000)
					 		
					 		$('#message').text('');
					 		$('#compile-required').fadeOut();
					 	}
					});
					
					return false;
				});
			})(jQuery);
			</script>
			
			
		
		<?php return ob_get_clean();
		
		
	}

}
?>