<?php defined('JPATH_PLATFORM') or die;

class JFormFieldZenContent extends JFormField
{

	public $type = 'Zencontent';

	// Stores the options available for each content source
	// Displays the content source

	protected function getInput()
	{
		
		// Initialize variables.
		jimport('joomla.filesystem.folder');
		$path	= JPATH_ROOT.'/modules/mod_zentools2/settings/sources/';
		require_once __DIR__ . '/../includes/zentools2helper.php';
		
		// Instantiate the class
		$zen = new ZenTools2Helper();
		
	
		
		$files = JFolder::files($path,'', false, false ); ?>
		<!-- layout selector -->
		<div id="zt-content-source-settings" class="zt-admin hide">
			<h3 class="zt-title" id="zt-content-source">Select a content source
			<?php 
				
				foreach ($files as $key => $source)
				{ 
				
				
				 
				// List available layouts first
				// Get the layouts available
				// eg joomla, k2, gallery, images
				
				$source = JFile::stripExt($source); 
				$name = ucfirst(str_replace('-', ' ', $source));
				$name = str_replace('_', ' ', $name);	 
				
				
				if($zen->{$source}()) { 
					// Remove ZT from display
					$name = ucfirst(str_replace('Zt ', '', $name));
				?>
				
				<span class="zt-content-source" data-name="<?php echo $name;?>" data-id="<?php echo $source;?>">
					<a href="#">
							<span class="uk-badge uk-badge-notification"><?php 
								echo $name;
						?></span>
					</a>
				</span>
					
				<?php 
					// Loop through all of the available content sources
					// and then add all of the possible layotu tags for this content source
					// eg title, image, introtext, tags etc
					
						$items = JFactory::getXML($path . $source . '.xml'); ?>
						<ul class="zt-hide" id="<?php echo $source;?>-items">
							<?php foreach ($items as $key => $item) { 
								$name = str_replace('_', ' ', $item);
								$name = str_replace('-', ' ', $name);
								?>
								<li data-width="12" data-type="<?php echo $item; ?>"><?php echo $name; ?><span class="tag-remove zen-icon zen-icon-remove remove-tag"></span><span class="tag-edit zen-icon zen-icon-pencil"></span></li>
							<?php } ?>
						</ul>
				<?php }	
				
				}?>
		</div>
		
		<script>
			jQuery(document).ready(function($) {
				
				$(document).on('click', '.zt-content-source', function() {
				
					var source = $(this).attr('data-id');
					var layout = $('#layouts .active').attr('data-id');
					
					// make the item source active
					$('.zt-content-source').removeClass('active').find('span').removeClass('uk-badge-success');
					$(this).addClass('active').find('span').addClass('uk-badge-success');
					
					var source_items = $('#' + source + '-items').html();
					$('#zt-content-items').html(source_items);
					
					
					// Set the source value
					$('#jform_params_source').val(source);
					
					
					
					// Check if items being added shopuld be in the layout tool
					// Remove if not
					// First create the array of items
					
					var items = [];
					$('#' + source + '-items li').each(function(i, value) {	
						var type = $(this).attr('data-type');
						items.push(type) 
					});
					
					
						
					// Null the status
					$('#zt-status').text('');
					
					var removed = "";
					
					// Remove items from the layout tool that dont exist in the new source
					$('#zt-item-layout-wrap li').each(function(i, value) {
						
						var type = $(this).attr('data-type');
						
						if(jQuery.inArray(type, items)!==-1) {
							
						} else {
							
							// Remove items from the layout tool
							$(this).remove();
							
							
							// Hide the module settings
							$('#' + type + '-settings.item-settings').hide().removeClass('active');
							
							// Add the name of the item to the array
							removed += type + " ";
						}
						
						
						// Remove items in the available tags that are already in the layout tool
						$('#zt-content-items li[data-type="'+ type +'"]').remove();
						
					});
					
					
					
					
					
					if(removed !=="") {
					
						var count_items = removed.replace(/\w/g, "").length;
						
						if(count_items > 1) {
							var text = " are ";
							var has = " have "; 
						}
						else {
							var text = " is ";
							var has = " has "; 
						} 
						
						$('#zt-status').html('<span class="zt-icon zen-icon-warning"></span> Please Note: ' + removed + text + 'not compatible with this content source and' + has +'been removed.').fadeIn().delay(4000).fadeOut();
					}
					
					
					$(document).on('click','.zt-content-source', function() {
					
						var current_source = $(this).attr('data-id');
						var current_layout = $('.zt-layout-item.active').attr('data-id');
						
						if(current_source == "images" && current_layout == "filter") {
						
							$('#zt-status').html('<span class="zt-icon zen-icon-warning"></span> Please Note: Filter type changed to category as tags are not available for this content source.').fadeIn().delay(10000).fadeOut();
							
							$('.zt-settings-node[data-name="filter"]').attr('data-value', 'category');
							
							$('.zt-settings-node[data-name="filter"] li').removeClass('active');
							$('.zt-settings-node[data-name="filter"] li[data-id="category"]').addClass('active');
							
						}
					});
				});
				
			});
		
		</script>
	<?php }
	
	function getLabel()
	{
		return '';
	}
}						