<?php defined('JPATH_PLATFORM') or die;

class JFormFieldZenItemLayout extends JFormField
{

	public $type = 'Zenitemlayout';

	// icons

	protected function getInput()
	{
		?><!-- layout selector -->
		<div id="zt-layout-tool" class="zt-admin hide">
			<h3 class="zt-title zt-toggler" id="zt-content-source">Item layout   <span class="uk-badge uk-badge-notification">Edit item layout</span></h3>
			<div class="zt-toggle"><p>Drag items from the available items on the left to the item layout on the right.</p>
			<!-- Status -->
			<div id="zt-status" class="zt-status hide uk-alert-warning uk-alert"><span></span></div>
			<ul id="zt-content-items" class="zt-item-tags connectedSortable"></ul>
			
			
			<div id="zt-layout-wrapper">
				<a href="#" id="zt-add-column" class="uk-button uk-button-primary"><span class="zen-icon zen-icon-plus"></span>Add a Column</a>
				<div id="item-layout-settings">
					<!-- Display items -->
					
					<div id="zt-item-layout-wrap"></div>
					
					<?php $tag_settings_path = JPATH_SITE.'/modules/mod_zentools2/settings/elements/';
					$tags_settings = Jfolder::files($tag_settings_path,'', false, false); ?>
					
					
					<div id="zt-item-settings" class="zt-admin">
						<?php foreach ($tags_settings as $key => $setting) { 
						
								// List the params for each item
								$type = JFile::stripExt($setting); 
								$details = JFactory::getXML($tag_settings_path.$setting); ?>
								
								<div id="<?php echo $type;?>-settings" class="item-settings hide">
									
									<h3 class="settings-title closed"><span class="zen-icon zen-icon-chevron-down"></span><?php echo ucfirst($type);?> Settings</h3>
									
									<ul class="hide settings-block">
										<?php foreach ($details as $element) { 
										
											$type = $element['type'];
											
											if(isset($element['class'])) {
												$class = $element['class'];
											} else {
												$class ='';
											}
											$name = $element['name'];
											$label = $element['label'];
											$description = $element['description'];
											$default = $element['default']; 
									
											if($element['display'] !== "undefined") {
												$display = $element['display']; 
											} else {
												$display = "block";
											}
											$depend = $element['depend']; 
											
											?>
											
											
											<li data-display="<?php echo $display;?>" data-type="<?php echo $type;?>" data-name="<?php echo $name;?>" data-value="<?php echo $default;?>" class="settings-item">
												<?php 
													include(JPATH_ROOT . '/modules/mod_zentools2/fields/tags/' . $type . '.php');
												?>
											</li>
										<?php }  ?>
										</ul>
									</div>
							<?php }?>
						</div>
					</div>
				</div>
			</div>
		</div>
	<?php }
	
	function getLabel()
	{
		return '';
	}
}						