<?php
/**
 * @package     Joomla.Plugin
 * @subpackage  System.Zentools2
 * @author      Joomlabamboo, ${TODAY}
 * @copyright   Copyright (c) 2015 Joomla Bamboo. All rights reserved.
 * @license     GNU General Public License version 2 or later
 * @version     1.0
 */

// no direct access
defined('_JEXEC') or die('Restricted access');


/**
 * Zen Tools Module Tags Helper.
 */

class PlgSystemZenTools2Helper
{
	public static function getModuleDetails($icon, $source, $layout)
	{
		// Get all Zen Tools modules
		// Add stags to the zentools modules
		$db		= JFactory::getDbo();
		$query	= $db->getQuery(true);

		$query->select('m.id, m.params');
		$query->from('#__extensions as e');
		$query->where('e.client_id = 0');
		$query->where('type = ' . $db->quote('module'));
		$query->where('element = ' . $db->quote('mod_zentools2'));
		$query->leftJoin('#__modules as m ON m.module=e.element AND m.client_id=e.client_id');
		$query->where('m.module IS NOT NULL');

		$db->setQuery($query);
		$modules = $db->loadObjectList();
		$doc = JFactory::getDocument();
		
		foreach ($modules as $key => $module) {
			
			$id = $module->id;
			$module_params = $module->params;
			$module_params = json_decode($module_params);
			
			
			// Start the js to inject
			$script = 'jQuery(document).ready(function($) {';
			$script .= ' $("#moduleList tr").each(function() {
					var id = $(this).find("td:last-child").text();
					 id = $.trim(id);
					 
					 if(id == '.$id.') { ';
			 // Add the icon if parameter is enabled
			 if($icon) {
			 		$script .='$(this).find(".has-context a").not(".btn-micro").prepend("<img src=\"http://zentools.joomlabamboo.com/images/zentools400.png\" style=\"width:16px;margin-right:10px\" />");';
			 }
			 		
			
			// See if we have params
			if(is_object($module_params)) {
				$layout_source = $module_params->layout;
				$content_source = $module_params->source;
				
				
				// Add content source		 	
			 	if($source) {
			 		$script.= '$(this).find(".has-context").append("<span style=\"margin-left:10px\" class=\"label label-primary \">'.$content_source.'</span>");';
			 	}
			 	
			 	// Add layout type
			 	if($layout) {
			 		$script .= '$(this).find(".has-context").append("<span style=\"margin-left:10px\" class=\"label label-info \">'.$layout_source.'</span>");';
			 	}			
				
			}
			
							 	
			$script .= '}
			});';
			$script .= '});';
			
			$doc->addScriptDeclaration($script);
			
		}		
	}

}