<?php
/**
 * @version		$Id: helper.php 1832 2013-01-30 13:05:12Z lefteris.kavadas $
 * @package		K2
 * @author		JoomlaWorks http://www.joomlaworks.net
 * @copyright	Copyright (c) 2006 - 2013 JoomlaWorks Ltd. All rights reserved.
 * @license		GNU/GPL license: http://www.gnu.org/copyleft/gpl.html
 */

// no direct access
defined('_JEXEC') or die;

require_once (JPATH_SITE.'/components/com_k2/helpers/route.php');
require_once (JPATH_SITE.'/components/com_k2/helpers/utilities.php');


class k2
{

	public static function getList(&$params, $format = 'html')
	{
	
		// Content Source
		$source = $params->get('k2_content_type', 'categories');
		
		// Featured
		$show_featured = $params->get('k2_featured', '');
		
		// Ordering
		$order = $params->get('k2_ordering', 'name DESC');	
		
		// Item count
		$count = $params->get('k2_count', '5');
		
		
		// Link Type
		$link_type = $params->get('k2_link_type', 'item');
		
		// Get the layout item settings
		// We need this to get some of the values for related items.
		
		$settings = json_decode($params->get('layout_settings'));
		
		$strict_readmore = 0;
		
		foreach($settings as $key=>$colcontent) {
			
			foreach ($colcontent as $name =>$item_content) {
				if($name == 'readmore') {
		    		if(isset($item_content->strict_readmore)) {
		    			$strict_readmore = $item_content->strict_readmore;
		    		}
		    	 }
		    }
		}
		
		
		// Define DB
		$db = JFactory::getDbo();
		$query = $db->getQuery(true);
		
		// Set current time to see if items should be published
		$nullDate	= $db->getNullDate();
		$date = JFactory::getDate();
		$now = $date->toSql();
		
		
		if($source == "categories") {
			
			$cats = json_decode($params->get('k2_content_categories_limit', ''));
			
			// Cast object to an array
			$catitems = (array)$cats;
			
			// Get catids from array
			$catids = array_keys($catitems);
			
			// Count number of cats to process
			$limitcount = count($catitems);
			
			// Get view access levels for current user id
			$user = JFactory::getUser();
			$viewLevels = JAccess::getAuthorisedViewLevels(JUserHelper::getUserId($user->username));
			$access_levels = implode(",", $viewLevels);	
			
			
	
			// If just a single value then proceed as usual
			if($limitcount <= 1) {
			
				// If no limits on category numbers we just perform the standard query
				$db = JFactory::getDBO();
				$query	= $db->getQuery(true);
				$query->select('a.*');
				$query->from('#__k2_items AS a'); 
				
				if(!empty($catids)) {
					$query->where('a.catid in (' . implode(',', $catids) . ')');
				    $query->where('a.published = 1')->where('a.trash != 1');
				}
				
				// Featured
				if($show_featured == 0) {
					$query->where('a.featured = 0');
				} elseif($show_featured == 1) {
					$query->where('a.featured = 1');
				} 
				
				$query->where('published = 1')->where('a.trash != 1');
				$query->where("access in ($access_levels)");
				$query->where('publish_down = '.$db->Quote($nullDate).' OR publish_down >= '.$db->Quote($now));
				$query->where('publish_up <= '.$db->Quote($now));
				
				if(isset($catids[0])) {
					$limit = $cats->{$catids[0]};
					
					if($limit > $count || $limit =="") {
						$limit = $count;
					}
										
				} else {
					$limit = $count;
				}
								
				$query->order($order);
				$db->setQuery($query, 0, $limit);
				$datas = $db->loadObjectList();
				
			} else {
			
				// Get items from each category limited by number set in admin
				// To do this we need to union the selects
				// and then apply an order at the end
				
				$db = JFactory::getDbo();
				$query = $db->getQuery(true);
				
				// Loops through the catd ids and limits set
				// catid:limit
				// 42:2
			
				// We need to calculate the new total items to display
				// Check later to see if it's higher or lower than the count amount
				$total = '';
			
				foreach ($cats as $catid => $limit) {
					
					
					// If limit is left blank in the settings
					if($limit == "") {
						$limit = $count;
					}
					
					// Set up the union query
					${'q'.$catid} = $db->getQuery(true);
					
					// Create the select for each cat
					${'q'.$catid}
					   ->select('*')
					   ->from('#__k2_items')
					   ->where('published = 1')
					   ->where('trash != 1')
					   ->where("access in ($access_levels)")
					   ->where('catid = '.$catid.'')
					   ->where('publish_down = '.$db->Quote($nullDate).' OR publish_down >= '.$db->Quote($now))
					   ->where('publish_up <= '.$db->Quote($now))
					   ->order(''.$order.'');
					   
					   // Featured items
					    if($show_featured == 0) {
					    	${'q'.$catid}->where('featured = 0');
					    } elseif($show_featured == 1) {
					    	${'q'.$catid}->where('featured = 1');
					    } 
					    
					    // Limit the items from this category
					    ${'q'.$catid}->setLimit($limit);
					    
					    $total += $limit;
				}
				
				
						
				// Perform the base query
				// First item is a dummy
				// Then loop through the unions
				// created int he previous step
				
				$query
				    ->select('*')
				    ->from('#__k2_items')
				    ->where('1 = 0');
				    
				 foreach ($cats as $catid => $limit) {
				   	$query->union(${'q'.$catid});
				 }
				 
				$query .= ' ORDER BY '.$order.' ';			
					
				
				 // If the total number of items is less than the count
			    if($total < $count) {
			    	$query .= ' LIMIT ' . $total ;
			    } else {
			    	$query .= ' LIMIT  ' . $count ;
			    }
			    
			  
			    // Set the query
			    $db->setQuery($query);	
				
				// The final array    	    	    
			    $datas = $db->setQuery($query)->loadObjectList();	
					
			}
			
			
		}
		else {
	
			$id = $params->get('k2_content_items', '');
			$id = implode(",", $id);	
			
			$db = JFactory::getDbo(); 
			$query = $db->getQuery(true); 
			$query->select(array('*')) 
			      ->from($db->quoteName('#__k2_items')) 
			      ->where('ID in ('.$id.')');
			      
			if($show_featured == 0) {
			     	$query->where('featured = 0');
			} elseif($show_featured == 1) {
			      	$query->where('featured = 1');
			} 
			      
			$query->order(''.$order.'');
			$db->setQuery($query,0,$count); 
			$datas = $db->setQuery($query)->loadObjectList();	
		}
		
		// Number of items
		$i = 0;
		
		// Manual Links
		$manual_links = null;
		
		if($link_type =="manual") {
			$manual_links = explode(PHP_EOL, $params->get('k2_manual_links'));
		}
			
			
			
			
		if (count($datas))
		{
			$model = K2Model::getInstance('Item', 'K2Model');

			foreach ($datas as $key => $data)
			{
			    $item = new stdClass;
			   			    
			    $category = self::get_k2_cat($data->catid); 
								
				// Clean title
				$item->title = JFilterOutput::ampReplace($data->title);
				$item->alias = $data->alias;
				
				$item->id = $data->id;
				
				// Introtext
				$item->introtext = $data->introtext;
				
				// Fulltext
				$item->fulltext = $data->fulltext;
				
				// Video
				$item->video = $data->video;
				$item->video_caption = $data->video_caption;
				$item->video_credit = $data->video_credits;
				
				// Gallery
				$item->gallery = $data->gallery;
				
				//Date
				$item->date = $data->created;
				$item->created = $data->created;
				$item->publishdate = $data->publish_up;
				
				// Time Since
				$item->time_since = self::humanTiming(strtotime($item->publishdate));
				
				
				// Hits
				$item->hits = $data->hits;
				
				
				// Extra Fields
				$item->extrafields = $model->getItemExtraFields($data->extra_fields, $data);
				
				
				// Featured
				$item->featured = $data->featured;
				
				// Category
				$item->catid = $data->catid;
				$item->category = $category[0]->name;
				$item->category_alias = $category[0]->alias;
				$item->catlink = urldecode(JRoute::_(K2HelperRoute::getCategoryRoute($data->catid.':'.urlencode($item->category_alias))));
				
			
				// Item Link
				
				$item->link = null;
					
				if($link_type =="manual") {
					if(isset($manual_links[$key])) {
						$item->link = $manual_links[$key];
					}  else {
						$item->link = null;
					}
				
				} else {
					$item->link = urldecode(JRoute::_(K2HelperRoute::getItemRoute($item->id.':'.urlencode($data->alias), $data->catid.':'.urlencode($item->category_alias))));
				
					if($strict_readmore && $item->fulltext =="") {
						$item->link = null;
					}
				}
				
				// Author
				if (!empty($item->created_by_alias))
				{
					$item->author = $item->created_by_alias;
					$item->authorGender = NULL;
					$item->authorDescription = NULL;
					if ($params->get('itemAuthorAvatar'))
						$item->authorAvatar = '';
					$item->authorLink = Juri::root(true);
				}
				else
				{
					$author = JFactory::getUser($data->created_by);
					$item->author = $author->name;

					$query = "SELECT `description`, `gender` FROM #__k2_users WHERE userID=".(int)$author->id;
					$db->setQuery($query, 0, 1);
					$result = $db->loadObject();
					if ($result)
					{
						$item->authorGender = $result->gender;
						$item->authorDescription = $result->description;
					}
					else
					{
						$item->authorGender = NULL;
						$item->authorDescription = NULL;
					}

					
					$item->avatar = '';
					
					//Author Link
					$item->authorLink = JRoute::_(K2HelperRoute::getUserRoute($data->created_by));
				}
				
				$image = 'media/k2/items/cache/'.md5("Image".$item->id).'_XL.jpg';
				if(file_exists($image)) {
					$item->image = $image;
				} else {
					$item->image = "";
				}
								
				
				
				
				// Tags
				$article_tags = $model->getItemTags($item->id);
				$item->tag_filter = null;
				$item->tags = null;
				
				if(!empty($article_tags)) {
					
					$item->tag_filter = array();
					
					for ($i = 0; $i < sizeof($article_tags); $i++)
						{
							$tagalias = strtolower(str_replace(' ', '-', $article_tags[$i]->name));
							$article_tags[$i]->link = JRoute::_(K2HelperRoute::getTagRoute($article_tags[$i]->name));
							$article_tags[$i]->title = $article_tags[$i]->name;
							$article_tags[$i]->alias = $tagalias;
						}
					
					$item->tags = $article_tags;
					$item->tags = $item->tags;					
				}
				/**************************************************
				 * Ratings
				 *************************************************/
				$rating = self::get_rating($item->id);
				$item->rating = $rating;
				
				$items[] = $item;
			}

			return $items;

		}

	}
	
	public static function get_rating($id) {
		
		$db = JFactory::getDbo(); 
		$query = $db->getQuery(true); 
		$query = 'SELECT *' . ' FROM #__k2_rating' . ' WHERE itemID = ' . $id;
		$db->setQuery($query);
		$rating = $db->loadObject();
		
		if(isset($rating->rating_sum)) {
			return $rating->rating_sum;
		} else {
			return 0;
		}
		
	}
	
	public static function get_k2_cat($category) {
		$db = JFactory::getDbo(); 
		$query = $db->getQuery(true); 
		$query->select(array('name', 'alias')) 
		      ->from($db->quoteName('#__k2_categories')) 
			  ->setLimit(1)
			  ->where($db->quoteName('id') . ' LIKE '. $category);
		$db->setQuery($query); 
		$rows = $db->loadObjectList();
		return $rows;
	}
	
	public static function humanTiming ($time)
	{
	
	    $time = time() - $time; // to get the time since that moment
	    $time = ($time<1)? 1 : $time;
	    $tokens = array (
	        31536000 => 'year',
	        2592000 => 'month',
	        604800 => 'week',
	        86400 => 'day',
	        3600 => 'hour',
	        60 => 'minute',
	        1 => 'second'
	    );
	
	    foreach ($tokens as $unit => $text) {
	        if ($time < $unit) continue;
	        $numberOfUnits = floor($time / $unit);
	        return $numberOfUnits.' '.$text.(($numberOfUnits>1)?'s':'');
	    }
	
	}
	

}
