<?php
/**
 * @package		Zen Tools
 * @subpackage	Zen Tools
 * @author		Joomla Bamboo - design@joomlabamboo.com
 * @copyright 	Copyright (c) 2013 Joomla Bamboo. All rights reserved.
 * @license		GNU General Public License version 2 or later
 * @version		1.8.5
 */

defined('_JEXEC') or die('Restricted access'); 



$class = ' zt-'.$options->theme;

if($options->margin) {
	$class .= ' zt-no-margin';
}

// Disable / enable drag events
$mouse_drag = 1;
if(isset($options->mouse_drag)) {
	$mouse_drag = $options->mouse_drag;
}

$touch_drag = 1;
if(isset($options->touch_drag)) {
	$touch_drag = $options->touch_drag;
}


// Load Matchheights
$match_height = "";

if($options->matchheight) { 
	$doc->addScript($media_path .'js/jquery.matchHeight-min.js');
	$match_height = 'data-match-height="zt-match-height"';
} ?>
<div id="zentools-<?php echo $module->id;?>" class="zentools owl-carousel <?php echo $class;?>">
	<?php foreach ($list as $key => $item) { 
	
	$item_class = '';
	if($item->featured) {
		$item_class .= ' zt-featured';
	}
	?>
		<div>
			<div class="zt-item<?php echo $item_class;?>">
				<?php foreach ($columns as $column => $colwidth) { ?>
					<div class="zt-col zt-col-<?php echo $colwidth;?> zt-column-<?php echo $column + 1;?>"> 
						<?php $elements = $layout->$column;
							$count = 1;
							$total_elements = count((array)$elements);
							
							foreach ($elements as $type => $element) {
								
								$settings->count = $count;
								if($count == 2) { ?>
									<div class="zt-item-container" <?php echo $match_height;?>>
								<?php }
								
								$zen->loadElement($element->type, $element, $item, $settings, $zen);
								
								if($count == $total_elements && $count !==1) { ?>
									</div>
								<?php } 
								$count ++;
							} ?>
						</div>
				<?php } ?>		
			</div>
		</div>
	<?php } ?>
</div>

<?php if($lightbox->enable) { $zen->loadBlock('lightbox', $module, $settings); } ?>

<script>
	jQuery(document).ready(function($) {
	 	$("#zentools-<?php echo $module->id;?>").owlCarousel({
		  	items: "<?php echo $options->largescreen_items;?>",
		  	itemsDesktop : [<?php echo $options->largescreen;?>,<?php echo $options->largescreen_items;?>], //5 items between 1000px and 901px
	  	    itemsDesktopSmall : [<?php echo $options->mediumscreen;?>,<?php echo $options->mediumscreen_items;?>], // betweem 900px and 601px
	  	    itemsTablet: [<?php echo $options->smallscreen;?>,<?php echo $options->smallscreen_items;?>], //2 items between 600 and 0
	  	    itemsMobile : false,
	  	    lazyLoad : true,
	  	    <?php if(!$mouse_drag) { ?>
	  	     	mouseDrag: false,
	  	     <?php } ?>
	  	     <?php if(!$touch_drag) { ?>
	  	      	touchDrag: false,
	  	      <?php } ?>
	  	    slideSpeed : <?php echo $options->slide_speed;?>,
	  	    paginationSpeed : <?php echo $options->slide_speed;?>,
	  	    <?php if($options->autoplay) { ?>
	  	           autoPlay : <?php echo $options->autoplay_speed;?>,
	  	          <?php } ?>
	  	    <?php if(!$options->pagination) { ?>
	  	        pagination: false,
	  	       <?php } ?>
	  	        
	  	      <?php if($options->paginationNumbers) { ?>
	  	      paginationNumbers: true,
	  	      <?php } ?>
	  	      
	  	     <?php if($options->navigation) { ?>
	  	      navigation: true,
	  	      navigationText: ["<?php echo $options->nav_prev;?>","<?php echo $options->nav_next;?>"],
	  	      <?php } ?>
	  	    scrollPerPage: false,
	  	    afterAction: function(el){
	               
	               $('#zentools-<?php echo $module->id;?> .owl-item').removeClass('active');
	               var current = parseInt(this.$owlItems.eq(this.currentItem).index());
	               var count = 2;
	               var i = 1;
	               
	              
	               
	               $('#zentools-<?php echo $module->id;?> .owl-item').each(function(index) {
	                
	                	if(index < count) {
		                	setTimeout(function() {
		                			$('#zentools-<?php echo $module->id;?>').find( '.owl-item:eq('+ i +')').addClass('active');
		                			
		                			i++;
		                	}, index * 100);
		                }
	                })
	            }
	  	   });
	  	   
	});
</script>