<?php
/**
 * @package		Zen Tools
 * @subpackage	Zen Tools
 * @author		Joomla Bamboo - design@joomlabamboo.com
 * @copyright 	Copyright (c) 2013 Joomla Bamboo. All rights reserved.
 * @license		GNU General Public License version 2 or later
 * @version		1.8.5
 */

defined('_JEXEC') or die('Restricted access'); 

// Only output read more if link exists
if($item->link) {
	
	if(!$element->custom_more) {
		$text = JText::_('COM_CONTENT_READ_MORE');
	} else {
		$text = $element->more_text;
	}
	
	if(!$element->button_class) {
		$element->button_class = '';
	}
	
	$lightbox = $settings->lightbox; 
	
	$more_class ='';
	
	if($element->overlay_more) {
		$more_class .= ' zt-overlay-more';
	}
	
	if($element->animate_more_overlay && $element->overlay_more) {
		$more_class .= ' zt-animate-overlay-more';
	}
	
	$more_class .= ' zt-'. $element->more_position;
	
	$responsive_classes = explode(' ', $element->responsive_classes);
	$responsive_classes = array_filter($responsive_classes);
	
	foreach ($responsive_classes as $key => $device) {
		$more_class .= ' zt-hidden-'.$device;
	}
	
	$data_description ="";
	
	if(isset($item->introtext)) {
	 	 $data_description ='data-description="'.htmlspecialchars($item->introtext).'"';
	}
	
	// Joomla contacts
	if(isset($item->misc)) {
	 	 $data_description ='data-description="'.htmlspecialchars($item->misc).'"';
	}
?>

<div class="zt-readmore zt-element zt-<?php echo $element->display;?><?php echo $more_class;?> zt-element-<?php echo $settings->count;?>">
	<?php if(($element->link =="1" || $element->link =="3") && $item->link) { ?>
		<a class="readon <?php echo $element->button_class;?>" href="<?php echo $item->link;?>"
		<?php if($element->link =="3") { ?>
		target="_blank"
		<?php } ?>>>
	<?php } elseif($element->link =="2" && $item->link) { ?>
		<a data-effect="mfp-<?php echo $lightbox->transition;?>" class="zt-lightbox <?php echo $element->button_class;?>"  title="<?php echo $item->title;?>" href="<?php echo $item->image;?>" <?php echo $data_description;?>>
	<?php } ?>
		<span><?php echo $text;?><?php if($element->add_title) { echo $item->title; }?></span>
	<?php if($element->link && $item->link) { ?>
	</a>
	<?php } ?>
</div>

	<?php if($element->animate_more_overlay) { ?>
	<script>
		// Adds class to parent item for obverlay
		jQuery(document).ready(function($) {
		
			$(document).on('mouseenter', '.zt-item', function() {
				$(this).addClass('animate-overlay').find('.zt-animate-overlay-more').fadeIn();
			});
			
			$(document).on('mouseleave', '.zt-item', function() {
				$(this).removeClass('animate-overlay').find('.zt-animate-overlay-more').fadeOut();
			});
		});
	</script>
	<?php } ?>
<?php } ?>