<?php
/**
 * @package		Zen Tools
 * @subpackage	Zen Tools
 * @author		Joomla Bamboo - design@joomlabamboo.com
 * @copyright 	Copyright (c) 2013 Joomla Bamboo. All rights reserved.
 * @license		GNU General Public License version 2 or later
 * @version		1.8.5
 */

defined('_JEXEC') or die('Restricted access'); 


$class = ' zt-'.$options->theme;
$class .= ' max-cols-'.$options->maxcols;

if($options->margin) {
	$class .= ' zt-no-margin';
}

if($options->imagesloaded) {
	$class .= ' wait-for-filter-images';
}

// Count number of items in layout
$count = count((array)$layout->{'0'});

// Set up some things we will use later
$filters = array();
$tags_exist = 0;
$notags = 0;


// Images dont have a tag option
if($source == "images") {
	$options->filter = 'categories';
}

// Overriding thefilter
if($options->override_filter) {
	
	$filter_list = explode(',', $options->custom_filter_order);
	
	foreach ($filter_list as $key => $filter) {
		$filter = ltrim($filter, ' ');
		$filter = rtrim($filter, ' ');
		$filter = strtolower(str_replace(' ', '-', $filter));
		$filters[] = $filter;
	}
	
	$tags_exist = 1;
	
} else {

	foreach ($list as $key => $item) {
	
		if($options->filter =="tags") { 
			
			if($item->tags) {
				
				$tags = $item->tags;
				
				if(is_array((array)$tags)) {
					$tags_exist = 1;
				
					foreach ($tags as $key => $tag) {
					
						if (!in_array($tag->alias, $filters)) :
							$filters[$tag->title] = $tag->alias;
						endif;
					}
				}
			} else {
				
				if($notags == 0) {
					// Removed check for tags
					// Will leave this in place in case it turns out we need a check
					// $notags = 1;
				}
			}
		}
		elseif($options->filter =="client") { 
			if (!in_array($item->client_alias, $filters)) :
				$tags_exist = 1;
				$filters[$item->client] = $item->client_alias;
				$filters = array_filter($filters);
			endif;
		} else {
		
			if (!in_array($item->category_alias, $filters)) :
				$tags_exist = 1;
				$filters[$item->category] = $item->category_alias;
				$filters = array_filter($filters);
			endif;
		}
	}
} 
?>
	<?php if($tags_exist == 1) { ?>	
	<div id="filters-<?php echo $module->id;?>" class="zt-filter-list <?php echo $options->navbar_style;?>">
	
		<ul id="filter-<?php echo $module->id;?>" class="filter-nav pager-list">
			<?php if($options->showall) { ?>
				<li class="filter-<?php echo $module->id;?>" data-filter="all"><span class="<?php echo $options->navbar_style;?>"><?php echo $options->showall_text;?></span></li>
			<?php } ?>
			<?php 
			foreach ($filters as $key => $item) { 
			
			?>
				<?php if($item !=="") { ?>
				<li class="filter-<?php echo $module->id;?>" data-filter=".<?php echo $item;?>">
					<span class="<?php echo $options->navbar_style;?>">
						<?php echo $key;?>
					</span>
				</li>
				<?php } ?>
			<?php } ?>
	    </ul>
	    <?php if($options->display_sort) {?>
	    <ul id="sort-<?php echo $module->id;?>" class="sort-nav">
	    	<li class="sort-<?php echo $module->id;?>" data-sort="default"><span class="<?php echo $options->navbar_style;?>"><?php echo JText::_('MOD_ZENTOOLS2_FILTER_DEFAULT'); ?></span></li>
	  		<li class="sort-<?php echo $module->id;?>" data-sort="myorder:asc"><span class="<?php echo $options->navbar_style;?>" class="btn"><?php echo JText::_('MOD_ZENTOOLS2_FILTER_ASC'); ?></span></li>
	   		<li class="sort-<?php echo $module->id;?>" data-sort="myorder:desc"><span class="<?php echo $options->navbar_style;?>"><?php echo JText::_('MOD_ZENTOOLS2_FILTER_DESC'); ?></span></li>
	   		<li class="sort-<?php echo $module->id;?>" data-sort="random"><span class="<?php echo $options->navbar_style;?>"><?php echo JText::_('MOD_ZENTOOLS2_FILTER_RANDOM'); ?></span></li>
	   	</ul>
	   	<?php }?>
	</div>
	<?php } ?>

<div id="zentools-<?php echo $module->id;?>" class="zentools zt-filter zt-grid <?php echo $class;?>">
	<?php if($options->imagesloaded) {  $zen->loadBlock('loader', $module, $options); } ?>
	<ul>
		<?php foreach ($list as $key => $item) { 
		
			if($options->filter =="tags") { 
				
				$filterby = "";
				
				if($item->tags) {
					$tags = $item->tags;
					
					if(is_array((array)$tags)) {
						foreach ($tags as $key => $tag) {
							$filterby .= ' '.$tag->alias;
						}
					}
				}
			} elseif($options->filter =="client") { 
				
				$filterby = $item->client_alias;
			}
			else {
				$filterby = $item->category_alias;
			}
			
			$item_class = '';
			if($item->featured) {
				$item_class .= ' zt-featured';
			}
		
		$e = '0';
		?>
		<li grid-col="1/<?php echo $options->maxcols;?>" class="zt-item zt-item-<?php echo $module->id;?> <?php echo $filterby;?><?php echo $item_class;?> zt-item-<?php echo $key + 1;?>" data-myorder="<?php echo $key;?>">
				<?php foreach ($columns as $column => $colwidth) {  ?>
					<div class="zt-col zt-col-<?php echo $colwidth;?> zt-column-<?php echo $column + 1;?>"> 
						<?php $elements = $layout->$column;
							
							$count = 0;
							$total_elements = count((array)$elements);
							
							foreach ($elements as $type => $element) {
								
								$settings->count = $count;
								
								if($count == 1) { ?>
									<div class="zt-item-container">
								<?php }
								
								$zen->loadElement($element->type, $element, $item, $settings, $zen);
								
								if($count == $total_elements) { ?>
									</div>
								<?php } 
								$count ++;
							} ?>
						</div>
				<?php } ?>		
			</li>
		<?php } ?>
	</ul>
</div>

<?php if($lightbox->enable) { $zen->loadBlock('lightbox', $module, $settings); } ?>

<script>
	jQuery(document).ready(function($) {
	
		$('#zentools-<?php echo $module->id;?>').mixItUp({
			animation: {
				enable: true,
				<?php if($options->easing) {?>
				easing: 'cubic-bezier(0.175, 0.885, 0.32, 1.275)',
				<?php } ?>
				effects: '<?php echo $options->effects;?> stagger(<?php echo $options->stagger_speed;?>ms)',
						staggerSequence: function(i){
							return i % <?php echo $options->maxcols;?>
						}	
			},
			<?php if($options->active !=="") { ?>
			load: {
				filter: '.<?php echo strtolower(str_replace(' ', '-', $options->active));?>'
			},
			<?php } ?>
			layout: {
				display: 'inline-block'
			},
			
			selectors: {
				target: '.zt-item-<?php echo $module->id;?>',
				filter: '.filter-<?php echo $module->id;?>',
				sort: '.sort-<?php echo $module->id;?>'
			},
			callbacks: {
					onMixLoad: function(state){
						<?php if($options->imagesloaded) { ?>
							$('#zentools-<?php echo $module->id;?>.wait-for-filter-images img').each(function() {
								var image = $(this).attr('data-src');
								$(this).attr('src', image).fadeIn();
							});
						<?php } ?>
					},
					
					onMixStart: function(state){
						var height =  $('#zentools-<?php echo $module->id;?>').height();
						$('#zentools-<?php echo $module->id;?>').css({'min-height': height});
							
					},
					
					onMixEnd: function(state){
						var height =  $('#zentools-<?php echo $module->id;?> ul').height();
						$('#zentools-<?php echo $module->id;?>').css({'min-height': height});
					}
				}
		});
		
		
		<?php if($options->matchheight) { ?>
			// Equal heights
			 var bigbrother = -1;
			
			$('#zentools-<?php echo $module->id;?> .zt-item').each(function() {
			    bigbrother = bigbrother > $('#zentools-<?php echo $module->id;?> .zt-item').height() ? bigbrother : $('#zentools-<?php echo $module->id;?> .zt-item').height();
			});
			
			$('#zentools-<?php echo $module->id;?> .zt-item').each(function() {
			    $(this).height(bigbrother);
			});
		<?php } ?>
		
		// Active button state
		// For compatibility with zentools v1 markup 
		// Future themes can just use li.active a
	
		$('#filter-<?php echo $module->id;?> a').click(function(event) {
			$('#filter-<?php echo $module->id;?> a').removeClass('active');
			$(this).addClass('active');
			event.preventDefault();
		});
		
		$('#sort-<?php echo $module->id;?> a').click(function(event) {
			$('#sort-<?php echo $module->id;?> a').removeClass('active');
			$(this).addClass('active');
			event.preventDefault();
		});
		
		// Set the active button
		<?php if($options->active !=="") { ?>
			$('#filter-<?php echo $module->id;?> li[data-filter="all"] a').addClass('active');
		<?php } else { ?>
			$('#filter-<?php echo $module->id;?> li[data-filter=".<?php echo $options->active;?>"] a').addClass('active');
		<?php } ?>
		
		$('#sort-<?php echo $module->id;?> li[data-sort="default"] a').addClass('active');
		
	});
</script>


<?php if($options->imagesloaded) {  ?>
<script>
jQuery(document).ready(function($) {
	$('#zentools-<?php echo $module->id;?>.wait-for-images').imagesLoaded( function() {
	  	$('#zentools-<?php echo $module->id;?> .loading-wrap').fadeOut("normal", function() {
	  		$('#zentools-<?php echo $module->id;?>.wait-for-filter-images img').each(function() {
	  			var image = $(this).attr('data-src');
	  			$(this).attr('src', image).fadeIn();
	  		});
	  		
	  		$('#zentools-<?php echo $module->id;?>').removeClass('wait-for-images');
	 	});
	 });
});
</script>

<?php } ?>

<?php 

if($notags) {
	$application = JFactory::getApplication();
	$application->enqueueMessage(JText::_('TAGS_NOT_AVAILABLE'), 'warning');
}
?>