<?php
/**
 * @package		Zen Tools
 * @subpackage	Zen Tools
 * @author		Joomla Bamboo - design@joomlabamboo.com
 * @copyright 	Copyright (c) 2013 Joomla Bamboo. All rights reserved.
 * @license		GNU General Public License version 2 or later
 * @version		1.8.5
 */

defined('_JEXEC') or die('Restricted access'); 

$last = "";
$class = ' zt-'.$options->theme;

if($options->margin) {
	$class .= ' zt-no-margin';
}

if($options->imagesloaded) {
	$class .= ' wait-for-images';
}

// Count number of items in layout
$count = count((array)$layout);
$class .= ' zt-columns-'.$count;

// Load Matchheights
$match_height = "";

if($options->matchheight) { 
	$doc->addScript($media_path .'js/jquery.matchHeight-min.js');
	$match_height = 'data-match-height="zt-match-height"';
} ?>

<div id="zentools-<?php echo $module->id;?>"  class="zentools zt-grid zt-responsive-grid <?php echo $class;?>">
	<?php if($options->imagesloaded) {  $zen->loadBlock('loader', $module, $options); } ?>
	<ul>
		<?php foreach ($list as $key => $item) { 
		
		$item_class = '';
		if($item->featured) {
			$item_class .= ' zt-featured';
		}
		?>
			<li grid-col="1/<?php echo $options->maxcols;?>" <?php if($options->itemEffect) { ?> data-wow-delay="<?php echo 0.25 * $key;?>s"<?php }?> class="zt-item<?php echo $item_class;?><?php if($options->itemEffect) { ?>  zt-animate <?php echo $options->itemEffectType;?><?php }?> <?php if($options->maintain_grid) {?> zt-no-collapse<?php } ?> zt-item-<?php echo $key + 1;?>">
				<?php foreach ($columns as $column => $colwidth) { ?>
					<div class="zt-col zt-col-<?php echo $colwidth;?>"> 
						<?php $elements = $layout->$column;
							$count = 1;
							$total_elements = count((array)$elements);
							
							foreach ($elements as $type => $element) {
								
								$settings->count = $count;
								
								if($count == 2) { ?>
									<div class="zt-item-container" <?php echo $match_height;?>>
								<?php }
								
								$zen->loadElement($element->type, $element, $item, $settings, $zen);
								
								if($count == $total_elements && $count !==1) { ?>
									</div>
								<?php } 
								$count ++;
							} ?>
						</div>
				<?php } ?>		
			</li>
		<?php } ?>
	</ul>
</div>

<?php if($lightbox->enable) { $zen->loadBlock('lightbox', $module, $settings); } ?>

<?php if($options->imagesloaded) { ?>
<script>
jQuery(document).ready(function($) {

	$('#zentools-<?php echo $module->id;?>').imagesLoaded( function() {
		$('#zentools-<?php echo $module->id;?> .loading-wrap').fadeOut("normal", function() {
					
			$('#zentools-<?php echo $module->id;?> img').each(function() {
				var image = $(this).attr('data-src');
				$(this).attr('src', image);
			});
					
			$('#zentools-<?php echo $module->id;?> li.zt-item').fadeIn();
					
			$('#zentools-<?php echo $module->id;?>').removeClass('wait-for-images');
					
			<?php if($options->matchheight) { ?>
				$('#zentools-<?php echo $module->id;?> .zt-item-container').matchHeight();
			<?php } ?> 	
		});	
	});
});
</script>

<?php } ?>
