<?php
/**
 * @package		Zen Tools
 * @subpackage	Zen Tools
 * @author		Joomla Bamboo - design@joomlabamboo.com
 * @copyright 	Copyright (c) 2013 Joomla Bamboo. All rights reserved.
 * @license		GNU General Public License version 2 or later
 * @version		1.8.5
 */

defined('_JEXEC') or die('Restricted access'); 



$last = "";
$class = ' zt-'.$options->theme;

if($options->margin) {
	$class .= ' zt-no-margin';
}
$class .= ' max-cols-'.$options->maxcols;

// Count number of items in layout
$count = count((array)$layout);


// Extra sort
// filter array into their respective categories

$catarray = array();

foreach ($list as $key => $item) { 
	$category = strtolower(str_replace(' ', '-', $item->category));
	$catarray[$category][$key] = $item;
}

if($options->imagesloaded) {
	$class .= ' wait-for-images';
}

?>

<div id="zentools-<?php echo $module->id;?>" class="zentools zt-grid zt-grouped zt-responsive-grid <?php echo $class;?>">
	
	<?php if($options->imagesloaded) {  $zen->loadBlock('loader', $module, $options); } ?>
	
	<ul>
		<?php 
			foreach ($catarray as $section => $items) { 
				$total = count($items);
				$section = ucfirst(str_replace('-', ' ', $section)); ?>
		
		<li grid-col="1/<?php echo $options->maxcols;?>">
		
		<?php if($options->foldertitle) {?>
			<h3><?php echo $section;?> <?php if($options->itemcount) {?>(<?php echo $total;?>)<?php } ?></h3>
		<?php } ?>
			<ul>
				<?php foreach ($items as $key => $item) { ?>
					<li class="zt-item zt-item-<?php echo $key + 1;?>">
						<ul>
						<?php foreach ($columns as $column => $colwidth) { ?>
							<li class="zt-col zt-col-<?php echo $colwidth;?>">
							 <?php $elements = $layout->$column;
									$count = 0;
									$total_elements = count((array)$elements);
									
									foreach ($elements as $type => $element) {
										
										$settings->count = $count;
										
										if($count == 1) { ?>
											<div class="zt-item-container">
										<?php }
										
										$zen->loadElement($element->type, $element, $item, $settings, $zen);
										
										if($count == $total_elements) { ?>
											</div>
										<?php } 
										$count ++;
									
								} ?>
							</li>
						<?php } ?>
						</ul>	
					</li>				
				<?php } ?>
				
				<li class="zt-group-more-button">
					<?php if($item->catlink && $options->moreitemlink) { ?>
					<a class="readon <?php echo $options->btnclass;?>" href="<?php echo $item->catlink;?>"><?php echo $options->link_to_cat_text;?></a>
					<?php } ?>
				</li>
					
			</ul>
			
		</li>	
		<?php }?>
	</ul>
</div>

<?php if($lightbox->enable) { $zen->loadBlock('lightbox', $module, $settings); } ?>

<?php if($options->imagesloaded) {  ?>
<script>
jQuery(document).ready(function($) {
	$('#zentools-<?php echo $module->id;?>.wait-for-images').imagesLoaded( function() {
	  	$('#zentools-<?php echo $module->id;?> .loading-wrap').fadeOut("normal", function() {
	  		
	  		$('#zentools-<?php echo $module->id;?>.wait-for-images img').each(function() {
	  			var image = $(this).attr('data-src');
	  			$(this).attr('src', image);
	  		});
	  		
	  		$('#zentools-<?php echo $module->id;?>').removeClass('wait-for-images');
	  		$('#zentools-<?php echo $module->id;?> li.zt-item').fadeIn();	  		
	 	});
	 });
});
</script>

<?php } ?>